import React, { Component } from 'react';
import '../styles/App.css';

import { is_weixn } from '../utils';
import { APP_ID } from '../config';
import UserInfoContext, { defaultUserinfo } from '../context/userinfo-context';

import { Route, Switch } from 'react-router-dom';
import Report from './report/report';
import Login from './Login/Login';
import PublicCarList from './PublicCar/PublicCarList';
import PublicCarApply from './PublicCar/PublicCarApply';

class App extends Component {
  constructor(props) {
    super(props);

    this.updateUserInfo = data => {
      this.setState({
        userinfo: { ...this.state.userinfo, ...data },
      });
    };

    this.state = {
      isWx: is_weixn(),
      userContext: {
        userinfo: defaultUserinfo,
        updateUserInfo: this.updateUserInfo,
      },
    };
  }
  renderLogin = props => {
    // const { isWx } = this.state;
    const isWx = true;
    const { search } = props.location;
    const paramsString = search.substring(1);
    const searchParams = new URLSearchParams(paramsString);
    const openid = searchParams.get('openid');
    // const state = searchParams.get('state');
    console.log(isWx, openid);

    if (!isWx) {
      return <div>请在微信客户端打开链接</div>;
    } else if (!openid) {
      let rUrl = encodeURIComponent('');
      window.location.href = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=${APP_ID}&redirect_uri=${rUrl}&response_type=code&scope=snsapi_base&state=STATE#wechat_redirect`;
      return <div>授权中。。。</div>;
    } else {
      return <Login {...props} openid={openid} />;
    }
  };
  updateUserInfo = data => {
    this.setState({
      userContext: {
        ...this.state.userContext,
        userinfo: { ...this.state.userContext.userinfo, ...data },
      },
    });
  };
  render() {
    const { userContext } = this.state;

    return (
      <div className="App">
        <UserInfoContext.Provider value={userContext}>
          <Switch>
            <Route exact path="/" render={this.renderLogin} />
            <Route path="/report" component={Report} />
            <Route path="/PublicCarList" component={PublicCarList} />
            <Route path="/PublicCarApply" component={PublicCarApply} />
          </Switch>
        </UserInfoContext.Provider>
      </div>
    );
  }
}

export default App;
